;Blockbuster v4.5 for ZShell
;ZoomLabs Software
;Doug Torrance
;profzoom@hotmail.com

	#include "ti-85.h"
	.org 0
	.db "Blockbuster "
Version:
	.db "v4.5",0

; - Variables -

string = TEXT_MEM
lilguyx = TEXT_MEM+6
lilguyy = TEXT_MEM+7
score = TEXT_MEM+8
otherlilguyy = TEXT_MEM+9
yetanotherlilguyy = TEXT_MEM+11
initial = TEXT_MEM+12
RANDSEED = TEXT_MEM+50
Board = TEXT_MEM+51

; - Title screen -

	ld hl,ZS_BITS
	set 0,(hl)

Beginning:
	CALL_(DrawTitlePic)			;"Blockbuster v4.5"
	ld hl,TitleScreenInfo
	ld de,$200a
	CALL_(vputs)				;"Doug Torrance"
	ld d,$27			
	CALL_(vputs2)				;"ZoomLabs Software"
	ld d,$2e
	CALL_(vputs2)				;"profzoom@hotmail.com"
	ld d,$35
	CALL_(vputs2)				;"High Score - XXX - "
	ld hl,HighScore
	CALL_(AddProgAddress)
	ld a,(hl)				;ld hl,(hl)
	CALL_(DM_A_DECI)			;prints high score

TitleLoop:
	call GET_KEY
	cp $36
	jr z,Help
	cp 9
	jr z,Help				;go on if 2nd or ENTER is pressed
	cp $37
	ret z					;exit if MODE is pressed
	ld hl,RANDSEED
	inc (hl)				;randomize the RANDSEED
	jr TitleLoop



Help:
	CALL_(DrawTitlePic)
	ld hl,HelpScreenInfo
	ld de,$1d0a
	CALL_(vputs)				;"[RIGHT]&[LEFT]-move"
	ld d,$24
	CALL_(vputs2)				;"[F1]+[RIGHT]&[LEFT]-jump"
	ld d,$2b
	CALL_(vputs2)				;"[2nd]+[RIGHT],[LEFT],&[DOWN]-"
	ld d,$39
	CALL_(vputs2)				;"[EXIT]-exit"
	ld de,$3210
	CALL_(vputs2)				;"break block"

HelpLoop:
	call GET_KEY
	cp $36
	jr z,StartGame
	cp 9
	jr z,StartGame
	cp $37
	ret z
	ld hl,RANDSEED
	inc (hl)				;randomize the RANDSEED
	jr HelpLoop

; - Draw board -

StartGame:
	ld e,0
	ld hl,Board

WriteBoard:
;getrand.asm by Jason Todd:
  	push hl
	ld hl,(RANDSEED)
	ld a,h
	add a,a
	rl l
	rl h
	add a,a
	rl l
	rl h
	add a,a
	rl l
	rl h
	ld bc,$7415
	add hl,bc
	ld (RANDSEED),hl
	ld a,h
	add a,l
	pop hl
	          
	ld (hl),a
	inc hl
	inc e
	ld a,e
	cp 16
	jr nz,WriteBoard

LetsGetStarted:	
	ROM_CALL(CLEARLCD)
	ld de,0
	ld hl,Board

DrawRowOfBlocks:				;optimized by Kouri
	ld a,(hl)
	ld b,8
DrawRowLoop:
	rra
	push af
	jr nc,AfterDraw
DrawBlock:
	push bc
	push hl
	ld hl,Block
	CALL_(ZoomSprite)
	pop hl
	pop bc
AfterDraw:
	ld a,d
	add a,8
	ld d,a
	pop af
	djnz DrawRowLoop
	inc hl
	ld d,b
	inc e
	ld a,e
	cp 16
	jr nz,DrawRowOfBlocks

DrawManAndExitDoor:
	ld hl,Board
	res 0,(hl)
	ld hl,Board+15
	res 7,(hl)
	ld de,0
	ld hl,Man
	CALL_(ZoomSprite)
	ld de,$380f
	ld hl,Exit
	CALL_(ZoomSprite)

	xor a
	ld (score),a
	ld (lilguyx),a
	ld (otherlilguyy),a
	inc a
	ld (lilguyy),a
	ld a,%11111110
	ld (yetanotherlilguyy),a
	
Gravity:
	ld a,(otherlilguyy)
	ld d,a
	ld a,(lilguyx)
	ld e,a
	ld hl,Man
	CALL_(ZoomSprite)
	
	ld a,(otherlilguyy)
	cp 56
	jr z,WaitForKey
	CALL_(ColumnIntoHL)
	ld a,(lilguyy)
	rlca
	ld b,(hl)
	and b
	or a
	jr nz,WaitForKey
	CALL_(EraseLilGuy)
	ld a,(lilguyy)
	rlca
	ld (lilguyy),a
	ld a,(otherlilguyy)
	add a,8
	ld (otherlilguyy),a
	ld a,(yetanotherlilguyy)
	rlca
	ld (yetanotherlilguyy),a
	jr Gravity

WaitForSecond:
	ld a,$bf
	out (1),a
	in a,(1)
	bit 5,a
	JUMP_Z(SecondIsPressed)
	bit 4,a
	JUMP_Z(YEqualsIsPressed)
	
	
	

WaitForKey:
	call GET_KEY
	dec a
	dec a
	jr z,LeftKeyIsPressed
	dec a
	jr z,RightKeyIsPressed
	cp $34
	JUMP_Z(Beginning)
	ld a,(lilguyy)
	cp %10000000
	JUMP_Z(AreYouFinished)

GuessNot:
	jr WaitForSecond

LeftKeyIsPressed:
	ld a,(lilguyx)
	or a
	jr z,WaitForKey
	CALL_(ColumnIntoHL)
	dec hl
	ld b,(hl)
	ld a,(lilguyy)
	and b
	or a
	jr nz,WaitForKey
	CALL_(EraseLilGuy)
	ld hl,lilguyx
	dec (hl)
	JUMP_(Gravity)
	

RightKeyIsPressed:
	ld a,(lilguyx)
	cp 15
	jr z,WaitForKey
	CALL_(ColumnIntoHL)
	inc hl
	ld a,(lilguyy)
	and (hl)
	or a
	jr nz,WaitForKey
	CALL_(EraseLilGuy)
	ld hl,lilguyx
	inc (hl)
	JUMP_(Gravity)

YEqualsIsPressed:
	ld a,$fe
	out (1),a
	in a,(1)
	bit 1,a
	jr z,YEqualsLeftIsPressed
	bit 2,a
	jr z,YEqualsRightIsPressed
	JUMP_(WaitForSecond)

YEqualsRightIsPressed:
	ld a,(lilguyx)
	cp 15
	jr z,WaitForKey
	ld a,(otherlilguyy)
	or a
	JUMP_Z(WaitForKey)
	CALL_(ColumnIntoHL)
	inc hl
	ld a,(lilguyy)
	rrca
	and (hl)
	or a
	JUMP_NZ(WaitForKey)
	CALL_(EraseLilGuy)
	ld hl,lilguyx
	inc (hl)
	ld a,(lilguyy)
	rrca
	ld (lilguyy),a
	ld a,(otherlilguyy)
	sub 8
	ld (otherlilguyy),a
	ld a,(yetanotherlilguyy)
	rrca
	ld (yetanotherlilguyy),a
	JUMP_(GiveTime)

YEqualsLeftIsPressed:
	ld a,(lilguyx)
	or a
	JUMP_Z(WaitForKey)
	ld a,(otherlilguyy)
	or a
	JUMP_Z(WaitForKey)
	CALL_(ColumnIntoHL)
	dec hl
	ld a,(lilguyy)
	rrca
	and (hl)
	or a
	JUMP_NZ(WaitForKey)
	CALL_(EraseLilGuy)
	ld hl,lilguyx
 	dec (hl)
	ld a,(lilguyy)
	rrca
	ld (lilguyy),a
	ld a,(otherlilguyy)
	sub 8
	ld (otherlilguyy),a
	ld a,(yetanotherlilguyy)
	rrca
	ld (yetanotherlilguyy),a
	JUMP_(GiveTime)

SecondIsPressed:
	ld a,$fe
	out (1),a
	in a,(1)
	bit 1,a
	jr z,SecondLeftIsPressed
	bit 2,a
	jr z,SecondRightIsPressed
	bit 0,a
	jr z,SecondDownIsPressed
	JUMP_(WaitForSecond)

SecondLeftIsPressed:
	ld a,(lilguyx)
	or a
	JUMP_Z(WaitForKey)
	CALL_(ColumnIntoHL)
	dec hl
	ld a,(lilguyy)
	and (hl)
	or a
	JUMP_Z(WaitForKey)
	ld a,(yetanotherlilguyy)
	and (hl)
	ld (hl),a
	ld a,(otherlilguyy)
	ld d,a
	ld a,(lilguyx)
	dec a
	CALL_(DispNothing)
	ld hl,score
	inc (hl)
	call GET_KEY
	JUMP_(WaitForKey)

SecondRightIsPressed:
	ld a,(lilguyx)
	cp 15
	JUMP_Z(WaitForKey)
	CALL_(ColumnIntoHL)
	inc hl
	ld a,(lilguyy)
	and (hl)
	or a
	JUMP_Z(WaitForKey)
	ld a,(yetanotherlilguyy)
	and (hl)
	ld (hl),a
	ld a,(otherlilguyy)
	ld d,a
	ld a,(lilguyx)
	inc a
	CALL_(DispNothing)
	ld hl,score
 	inc (hl)
	call GET_KEY
	JUMP_(WaitForKey)

SecondDownIsPressed:
	ld a,(otherlilguyy)
	cp 56
	JUMP_Z(WaitForKey)
	CALL_(ColumnIntoHL)
	ld a,(lilguyy)
	rlca
	and (hl)
	or a
	JUMP_Z(WaitForKey)
	ld a,(yetanotherlilguyy)
	rlca
	and (hl)
	ld (hl),a
	ld a,(otherlilguyy)
	add a,8
	ld d,a
	ld a,(lilguyx)
	CALL_(DispNothing)
	ld hl,score
 	inc (hl)
	ld bc,0

GiveTime:
	inc b
	ld a,b
	cp $ff
	jr nz,GiveTime
	inc c
	ld a,c
	cp $80
	jr nz,GiveTime
	JUMP_(Gravity)

AreYouFinished:
	ld a,(lilguyx)
	cp 15
	JUMP_NZ(GuessNot)
	
YouAreFinished:
	ld de,$c2e
	ld hl,YourScore
	CALL_(vputs)
	ld a,(score)
	CALL_(DM_A_DECI)
	ld hl,HighScore
	CALL_(AddProgAddress)
	ld a,(score)
	cp (hl)
	jr z,Loop
	jr nc,YouGotTheHighScore
	
Loop:
	call GET_KEY
	cp 9
	JUMP_Z(Beginning)
	cp $37
	JUMP_Z(Beginning)
	jr Loop

YouGotTheHighScore:
	ld de,$130e
	ld hl,CongratulationsHighScore
	CALL_(vputs)
	ld de,$1921
	CALL_(vputs2)
	ld hl,HighScore
	CALL_(AddProgAddress)
	ld a,(score)
	ld (hl),a
	ld de,0
	
	
NewInitial:
	ld hl,$0704
	ld (CURSOR_ROW),hl
	ld hl,HighScoreBuffer
	CALL_(AddProgAddress)
	add hl,de
	push hl
	ld hl,HighScoreBuffer-1
	CALL_(AddProgAddress)
	CALL_(SAM)
	pop hl
	push hl
	ld a,e
	or a
	CALL_Z(HighlightFirst)
	dec a
	CALL_Z(HighlightSecond)
	dec a
	CALL_Z(HighlightThird)
	pop hl
	
	
EnterInitials:
	push hl
	call GET_KEY
	pop hl
	dec a
	jr z,EI_DownIsPressed
	dec a
	jr z,EI_LeftIsPressed
	dec a
	jr z,EI_RightIsPressed
	dec a
	jr z,EI_UpIsPressed
	cp 5
	JUMP_Z(Beginning)
	jr EnterInitials

EI_UpIsPressed:
	inc (hl)
	ld a,(hl)
	cp $5b
	jr nz,NewInitial
	ld (hl),$41
	jr NewInitial

EI_DownIsPressed:
	dec (hl)
	ld a,(hl)
	cp $40
	jr nz,NewInitial
	ld (hl),$5a
	jr NewInitial

EI_RightIsPressed:
	ld a,e
	cp 3
	jr z,NewInitial
	inc e
	jr NewInitial

EI_LeftIsPressed:
	ld a,e
	or a
	jr z,EnterInitials
	dec e
	jr NewInitial
	
; - Calls -

DrawTitlePic:	
	ROM_CALL(CLEARLCD)			;optimized by Sam Heald and OBD
	ld hl,Titlepic	  			;big "Blockbuster" picture
	CALL_(AddProgAddress)
	ld de,VIDEO_MEM
	ld bc,256
	ldir
	ld hl,VIDEO_MEM+256
	ld (hl),b
	ld bc,767
	ldir
	ld de,$1404
	ld hl,Man				
	CALL_(ZoomSprite)			;draw man
	ld de,$1405
	ld hl,Block
	CALL_(ZoomSprite)			;draw block
	ld de,$1102
        ld hl,Version
	CALL_(AddProgAddress)
	ld (CURSOR_ROW),de
	ROM_CALL(D_ZT_STR)			;"v4.5"
	ret

vputs:
	CALL_(AddProgAddress)
vputs2:
	ld (CURSOR_X),de			;set cursor position
vputs3:
	ROM_CALL(D_ZM_STR)			;write text
	ret


HighlightFirst:
	CALL_(SAM_INVERT)
	inc hl
	CALL_(SAM)
	inc hl
	jr SAM
	
HighlightSecond:
	dec hl
	CALL_(SAM)
	inc hl
	CALL_(SAM_INVERT)
	inc hl
	CALL_(SAM)
	inc hl
	ret

HighlightThird:
	dec hl
	dec hl
	CALL_(SAM)
	inc hl
	CALL_(SAM)
	inc hl
	CALL_(SAM_INVERT)
	inc hl
	inc hl
	ret

SAM:
	ld a,(hl)
	ROM_CALL(TX_CHARPUT)
	ret

SAM_INVERT:
	set 3,(iy+5)
	CALL_(SAM)
	res 3,(iy+5)
	ret

ColumnIntoHL:
	ld d,0
	ld a,(lilguyx)
	ld e,a
	ld hl,Board
	add hl,de
	ret

EraseLilGuy:
	ld a,(otherlilguyy)
	ld d,a
	ld a,(lilguyx)

DispNothing:
	ld e,a
	ld hl,Nothing

ZoomSprite:
	push de
	push hl
	ld h,0
	ld l,d
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld a,e
	ex de,hl
	ld h,0
	ld l,a
	add hl,de
	ex de,hl
	pop hl
	CALL_(AddProgAddress)
	ld b,8

ZS_Draw:
	push hl
	ld a,(hl)
	ld hl,VIDEO_MEM
	add hl,de
	ld (hl),a
	ld hl,16
	add hl,de
	ex de,hl
	pop hl
	inc hl
	djnz ZS_Draw
	pop de
	ret

AddProgAddress
	push de
	ld de,(PROGRAM_ADDR)
	add hl,de
	pop de
	ret

;--- Jimmy Mardell's DM_HL_DECI Code--tweaked a little bit, displays a instead of hl
DM_A_DECI:
	ld l,a
 	ld h,0
	ld de, string+5
	xor a
	ld (de), a
DM_A_DECI_Repeat:
	call UNPACK_HL
	add a, '0'
	dec de
	ld (de), a
	ld a, h
	or l
	jr nz, DM_A_DECI_Repeat
	ex de, hl
	JUMP_(vputs3)

; - Strings -

TitleScreenInfo:	
	.db "Doug Torrance",0
	.db "ZoomLabs Software",0
	.db "profzoom@hotmail.com",0
	.db "High Score - "
	
HighScoreBuffer:
	.db "DAT - ",0

HighScore:
	.db 0

HelpScreenInfo:
	.db "[",$cf,"]&","[",5,"]-move",0
	.db "[F1]+","[",$cf,"]&","[",5,"]-jump",0
	.db "[2nd]+","[",$cf,"],","[",5,"]&","[",7,"]-",0
	.db "[EXIT]-exit",0
	.db "break block",0
	
YourScore:
	.db "Score-",0

CongratulationsHighScore:
	.db "Congratulations!  High Score!",0
	.db "Enter your initials..."

; - Sprites -

Nothing:	;just a blank 8x8 sprite, and since first 8 bytes of Titlepic are 0, I can save some space!			
Titlepic:	;Created with the Assembly Toolbox by Spooky
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000110,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00001111,%11111110,%00000111,%10000000,%00000000,%00000000,%00001110,%00000000,%11110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00001111,%11111111,%00000011,%11000000,%00000000,%00000000,%00001111,%00000000,%01111000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000
	.db %00000111,%10000111,%10000011,%11000000,%00000000,%00000000,%00001111,%00000000,%01111000,%00000000,%00000000,%00000000,%00000110,%00000000,%00000000,%00000000
	.db %00000111,%10000111,%11000011,%11000000,%00000000,%00000000,%00001111,%00000000,%01111000,%00000000,%00000000,%00000000,%00000111,%10000000,%00000000,%00000000
	.db %00000111,%10000111,%11000011,%11000111,%11110000,%00111111,%00001111,%00111000,%01111111,%11000011,%00001110,%00011111,%10011111,%10001111,%11100001,%11111100
	.db %00000111,%11011111,%11000011,%11001100,%00111100,%01100011,%11001111,%11110000,%01111111,%11100011,%10001111,%00111001,%10001111,%10011100,%11110001,%11111110
	.db %00000111,%11111111,%10000011,%11011110,%00011110,%11100011,%11001111,%11000000,%01111111,%11110111,%11001111,%00111100,%10001111,%10011111,%11111001,%11111100
	.db %00000111,%11001111,%11000011,%11011110,%00001111,%11100000,%00001111,%11100000,%01111000,%11110111,%11001111,%00111111,%00001111,%00011111,%11111001,%11110000
	.db %00000111,%10000011,%11100011,%11111110,%00001111,%11100000,%00001111,%11100000,%01111000,%11111111,%11001111,%00011111,%10001111,%00011110,%00000001,%11100000
	.db %00000111,%10000011,%11100011,%11111110,%00001111,%11110000,%00001111,%11110000,%01111000,%11111111,%11001111,%00000111,%11001111,%00011110,%00010001,%11100000
	.db %00000111,%10000011,%11100011,%11011110,%00011111,%11111001,%10001111,%11111000,%01111000,%11110111,%11001111,%10000001,%11101111,%10011111,%00110001,%11100000
	.db %00001111,%11001111,%11100111,%11001111,%00111110,%11111111,%10001111,%11111100,%01111111,%11100011,%11111111,%10111011,%11101111,%11011111,%11110001,%11100000
	.db %00001111,%11111111,%10000111,%11000111,%11110000,%00111111,%10001111,%00111110,%00111111,%00000001,%11111111,%10111111,%11000111,%11001111,%11110011,%11100000
	.db %00000011,%10000000,%00000000,%00000000,%00000000,%00001111,%00000000,%00000100,%00000000,%00000000,%11100000,%00000000,%00000001,%10000001,%11100000,%00000000
 
Man:	;new grafx thanx to Blackbelt, make the game look a bit nicer (from 83 version)
	.db %01111100
	.db %10101010
	.db %00010000
	.db %00111000
	.db %01111100
	.db %10111010
	.db %00010000
	.db %01101100
		
Block:
	.db %01111110
	.db %11010101
	.db %10101011
	.db %11010101
	.db %10101011
	.db %11010101
	.db %10101011
Exit:	.db %01111110
	
	.db %11111111
	.db %11000011
	.db %11000011
	.db %11000011
	.db %11000011
	.db %11000011
	.db %11000011

	
	

	.end